import  matplotlib.pyplot as plt
import numpy as np
# Variable Gap
x   = np.linspace(0,.3,100)   # define the range of the gap [0,.3d]
DC  = 1/(1-x)                 # define the 
DCi = 1+x
Del = DC-DCi
eDC = (DC-DCi)/DCi*100
# Differential Variable Gap
DCd  = 1/(1-x)-1/(1+x)
DCid = 2*x
Deld = DCd - DCid
eDCd = (DCd-DCid)/DCid*100
# Plotting
plt.rcParams['font.size'] = 20
def plotCMP( figNum, e1, e2, ylab):
    plt.figure(figNum)
    plt.clf()
    plt.axes((.2,.2,.7,.7))
    plt.plot(x, e1, color = 'k',linestyle = '-')
    plt.plot(x, e2, color = 'k',linestyle = '--',linewidth = 3)
    plt.grid(True)
    plt.xlabel('Normalized gap $x/d$')
    plt.ylabel(ylab)
    plt.legend(('Single','Differential'),loc = 2)

plotCMP( 1, Del, Deld, r'Linearity error $\times\epsilon_o\frac{A}{d}$')
plotCMP( 2, eDC, eDCd, 'Relative linearity error [%]')
plt.show()