import numpy as np
import matplotlib.pyplot as plt

plt.rcParams['font.size'] = 9
plt.rcParams['font.family'] = 'arial'
R = 1e9
C = 1e-12

tau = R*C
f = np.linspace(1,2e3,100)
w = np.pi*f

phi = np.arctan(1/(w*tau))*180/np.pi
H = w*tau/np.sqrt(1+(w*tau)**2)

plt.figure(figsize =(4,3),dpi = 150)
ax1 = plt.axes((.15,.6,.8,.35))
plt.plot( f, H, linewidth = 1, color = 'k')
#plt.grid(True)
plt.ylabel('Magnitude $|H_c|$')
plt.axes((.15,.15,.8,.35),sharex = ax1)
plt.plot(f, phi, linewidth = 1, color = 'k')
plt.xlabel('Frequency $f$ [Hz]')
plt.ylabel('Angle $\phi$ [$^o$]')
#plt.grid(True)
plt.gca().set_yticks((0,30,60,90))

plt.show()
plt.savefig('Fig_5p8.eps')