import numpy as np
import matplotlib.pyplot as plt

plt.rcParams['font.size'] = 20
wm = 1.
ws = 20.
t = np.linspace(0,2*np.pi*ws/wm,1000)
Vm = (np.sign(np.sin(t))+1)                    # modulation carrier
x = 1+.1*np.cos(wm/ws*t)                       # displacement (modulating) signal
plt. figure()
ax = plt.axes((.15, .15, .7, .7))
plt.plot(t/ws/2/np.pi,Vm*x,color = 'k',linewidth = 2)
plt.show()
plt.xlabel(r'Normalized time $\omega_mt$')
plt.ylabel(r'[1+.1cos($\omega_m t$)]sign[sin($\omega_s t$)]')
plt.grid(True)
plt.title(r'$\omega_s = 10\times \omega_m$')
plt.show()