import matplotlib.pyplot as plt
import numpy as np

plt.rcParams['font.size'] = 9
plt.rcParams['font.family'] = 'arial'
fx = 1e3
fs = 10*fx


t = np.linspace(0,1/fx,1e3)
x = 1+.1*np.cos(2*np.pi*fx*t)
c = np.sign(np.sin(2*np.pi*fs*t))
xm = x*(c+1)/2
# s = x[np.floor(t*fs)]*c
ind1, = np.where(np.diff(c)>.3)
ind2, = np.where(np.diff(c)<-.3)
ind2 = np.append(ind2,len(x)-1)
ind = np.sort(np.append(ind1,ind2))

plt.figure(figsize = (5,4),dpi = 150)
plt.axes((.12,.15,.85,.75))
t = t*1e3
plt.plot(t,x,color = 'gray',linestyle = '--',linewidth = 1,label = r'$v_{out}(t)$')
plt.hold(True)
# plt.plot(t,xm)
x[ind2] = 0
#plt.grid(True)
plt.step(t[ind],x[ind],color = 'k',linewidth = 1,where = 'post',
          label = r'$\frac{V_B}{2C_f}\left(C_o+\frac{dC}{dx}\vert_{x\leftarrow 0}x^{\prime}\right)$')
plt.xlabel('Time $t$ [ms]')
plt.ylabel(r'Output voltage $v_{out}(t)$')
plt.legend(loc = 'center left')
plt.title(r'$\omega_s = 10\times \omega_m$')
plt.gca().set_ylim((-.1, 1.2)	)
plt.show()
plt.savefig('Fig_5p28.eps')
# ts = np.floor(t/1e3*fs)/fs
# plt.plot(ts*1e3,np.zeros(len(ts)),marker = 's',linestyle = 'none')
# plt.draw()