import numpy as np
# - discretization level
n = 4
# - geometry L-length, w-width, h-height all in um
L = 100e-6
w = 4e-6
h = 2e-6
# - material properties
Y = 169e9   # Pa
rho = 2330  # kg

# - calculations
I = h**3*w/12   # area moment
a = np.zeros((n,n))
for i in range(n):
    for j in range(i+1):
       a[i,j] = L**3/(6*n**3*Y*I)*(3.*(i+1)*(j+1)**2-(j+1)**3)
       a[j,i] = a[i,j]

m = L*w*h/n*rho*np.eye(n)
k = np.linalg.inv(a)

