import numpy as np
import matplotlib.pyplot as plt
#from enthought.mayavi import mlab
FS = 9
plt.rcParams['font.size'] = FS
N = 10
v = 5;
L, h, d = 200e-6, 1e-6, 2e-6
nu, Y, rho, eps0 = 0.3, 150e9, 2330, 8.854e-12
D = Y*h**3/12/(1-nu**2)
a = np.zeros((N,N))
m = np.zeros((N,N))
f = np.zeros((N,1))
w = np.zeros((N,1))
P = (v**2/2)*eps0/d**2
rG = np.zeros((N,1))
for i in np.arange(0,N):
	ro = (i+0.5)*L/N
	rG[i] = ro
	dA = 2*np.pi*ro*(L/N)
	f[i] = P*dA#/(2*pi*ro)
	m[i,i]= dA*h*rho
	w[i] = P*L**4/(64*D)*(1-(ro/L)**2)**2
	for j in np.arange(0,N):
		r = (j+0.5)*L/N
		if r>ro:
			G3 = ro/(4*r)*(((ro/r)**2+1)*np.log(r/ro)+(ro/r)**2-1)
		else:
			G3 = 0
			
		L3 = ro/(4*L)*(((ro/L)**2+1)*np.log(L/ro)+(ro/L)**2-1)
		L6 = ro/(4*L)*((ro/L)**2-1+2*np.log(L/ro))
		uo = L**3*(L6-2*L3)/2/D
		Mc = -L*(1+nu)*L6
		a[i,j] = (uo+Mc*r**2/2/D/(1+nu)+r**3/D*G3)/ro/2/np.pi
		



u = np.dot(a,f)
#Visualization
plt.figure(figsize = (6,3),dpi = 150)
ax = plt.axes([.12, .25, .35, .6])
plt.xlabel('Normalized displacements $x/r_a$\n\n(a)',fontsize=FS);
q = np.linspace(0,2*np.pi,200)
for (ri,ui) in zip(np.arange(0,1,.1),u/u[0]):
    xi =np.r_[ri*np.cos(q), (ri+.1)*np.cos(q[-1:0:-1])]
    yi =np.r_[ri*np.sin(q), (ri+.1)*np.sin(q[-1:0:-1])]
    plt.fill(xi,yi,color = ui*np.ones(3))
plt.ylabel('Normalized displacement $y/r_a$',fontsize=FS);
plt.axis('equal')
ax = plt.axes([.6, .25, .35, .6])
plt.plot(rG/L,u/u[0],color = 'k', linestyle = 'none', marker = 's',markersize = 6)
plt.hold 
plt.plot(rG/L,w/w[0],color ='gray',marker = 'o',linewidth = 1, markersize = 5)	
plt.grid
plt.gca().set_ylim(plt.gca().get_ylim()[::-1])

plt.xlabel('Normalized radius $r/r_a$\n\n(b)',fontsize=FS);
plt.ylabel('Normalized displacements $u(r)/u_o$',fontsize=FS)
# title('$u_o(MDF)$ = '+str(round(w[0][0]/u[0][0]*1e3)/1e3) + ' $u_o(theory)$ ',fontsize = FS)
leg = plt.legend(('MDF','Theoretical'),loc='upper left')
plt.setp(leg.texts[0],'size',FS)
		
# axes([.1, .1, .8, .4])
#r,q = meshgrid(linspace(0,L,N),linspace(0,2*pi,50))

#setp(gca(),'ylim',[1.05,-0.05])
plt.show()

# w,phi = eig(dot(transpose(a)*m))
# plot(phi[:,0])

for xt in getp(ax.xaxis,'ticklabels'):
	setp(xt,'fontsize',FS)
	
for yt in getp(ax.yaxis,'ticklabels'):
	setp(yt,'fontsize',FS)
			
print w[0]*1e6			
savefig('circMDFstaticDrive')
		
#figure(2)
#clf()
#e = (1-u/w*w[0]/u[0])*100
#plot(rG/L,e,color = 'k',linewidth = 2)
#xlabel('Normalized radius $r/r_a$',fontsize=FS);
#ylabel('Relative error $\epsilon$ [%]')