from pylab import *
from enthought.mayavi import mlab

n = 1		# current mode
N = 40		# Number of DOF
r_a, h = 200e-6, 1e-6
nu, Y, rho = 0.3, 150e9, 2330
D = Y*h**3/12/(1-nu**2)
a = zeros((N,N))
m = zeros((N,N))
for i in arange(0,N):
	ro = (i+0.5)*r_a/N
	m[i,i]= 2*pi*ro*(r_a/N)*h*rho
	for j in arange(0,N):
		r = (j+0.5)*r_a/N		
		if r>ro:
			G3 = ro/(4*r)*(((ro/r)**2+1)*log(r/ro)+(ro/r)**2-1)
		else:
			G3 = 0			
		L3 = ro/(4*r_a)*(((ro/r_a)**2+1)*log(r_a/ro)+(ro/r_a)**2-1)
		L6 = ro/(4*r_a)*((ro/r_a)**2-1+2*log(r_a/ro))
		uo = r_a**3*(L6-2*L3)/2/D
		Mc = -r_a*(1+nu)*L6
		a[i,j] = ((uo+Mc*r**2/2/D/(1+nu)+r**3/D*G3)	)/ro/2/pi
  
def plotModeShape():
    mlab.figure("Modal analysis",(1,1,1),(0,0,0))
    mlab.clf()
    r,phi = meshgrid(linspace(0,1,N),linspace(0,2*pi,N))
    ind = n-1
    uF = -v[:,ind]/max(abs(v[:,ind]))
    u=zeros((N,N)) # construct 3D displacements
    for i in arange(0,N):
        for j in arange(0,N):
            u[i,j] = uF[j]
    x, y = r*cos(phi), r*sin(phi)
    mlab.mesh(x,y,u,colormap = 'gray')  
    fStr = "%2.3f" % freq_kHz[ind]
    tit = 'Mode = ' + str(n) + ': f = ' + fStr + ' kHz'
    mlab.title(tit,size =12)

			
w,v = eig(dot(a,m))
freq_kHz = 1/sqrt(w)/2/pi/1e3
plotModeShape()
# Visualization:








# coeff = (1.015, 2.007, -5)
if n == 1:
    coeff = 1.0174
elif n == 2:
    coeff = 2.0074
elif n == 3:
    coeff = 3.0047
fTheory_kHz = (coeff*pi/r_a)**2 * sqrt(D/rho/h)/2./pi/1.e3
print "Theoretical frequency [kHz] = " + "%2.3f" % fTheory_kHz