from pylab import *
from enthought.mayavi import mlab

n = 1		# current mode
N1 = 10
N2 = 8
N = N1*N2		# Number of DOF
r_a, h = 200e-6, 1e-6
nu, Y, rho = 0.3, 150e9, 2330
D = Y*h**3/12/(1-nu**2)
a = zeros((N,N))
m = zeros((N,N))
# Roark's constants:
bo = 3*(2+nu)/2/(1+nu)
b1 = 2*(4+nu)/2/(3+nu)
b2 = 2*(5+nu)/(4+nu)
co = (4+nu)/2/(1+nu)
c1 = (6+nu)/2/(3+nu)
c2 = (6+nu)/(4+nu)
dq = 2*pi/N2
dr = r_a/N1
for i in arange(0,N):
    i1 = floor(i*1.0/N1)
    i2 = i % N1 + 1
    ri = r_a*i1/N1 
    qi = 2*pi*i2/N2
    Ko = 1/(pi*D*r_a**4)*2*(1+nu)/9/(5+nu)*(ri**3-bo*r_a*ri**2+co*r_a**3)
    K1 = 1/(pi*D*r_a**6)*2*(3+nu)/3/(9+nu)*(ri**4-b1*r_a*ri**3+c1*r_a**3*ri)
    K2 = 1/(pi*D*r_a**6)*2*(4+nu)**2/(9+nu)/(5+nu)*(ri**4-b2*r_a*ri**3+c2*r_a**2*ri**2)
    for j in arange(0,N):
        j1 = floor(i*1/N1)
        j2 = j % N1 + 1
        rj = r_a*j1/N1
        qj = 2*pi*j2/N2
        a[i,j] = Ko*(rj**3-bo*r_a*rj**2+co*r_a**3)+K1*(rj**4-b1*r_a*rj**3+c1*r_a**3*rj)*cos(qj-qi)+K2*(rj**4-b2*r_a*rj**3-c2*r_a**2*rj**2)*cos(2*(qj-qi))
        m[j,j] = rj*dq*dr*rho*h
			
w,v = eig(dot(a,m))
freq_kHz = 1/sqrt(w)/2/pi/1e3
# Visualization:
mlab.figure("Modal analysis",(1,1,1),(0,0,0))
mlab.clf()
r,phi = meshgrid(linspace(0,1,N),linspace(0,2*pi,N))
ind = n-1
uF = -v[:,ind]/max(abs(v[:,ind]))
u=zeros((N,N)) # construct 3D displacements

fStr = "%2.3f" % freq_kHz[ind]
tit = 'Mode = ' + str(n) + ': f = ' + fStr + ' kHz'
mlab.title(tit,size =12)


# coeff = (1.015, 2.007, -5)
if n == 1:
    coeff = 1.0174
elif n == 2:
    coeff = 2.0074
elif n == 3:
    coeff = 3.0047
fTheory_kHz = (coeff*pi/r_a)**2 * sqrt(D/rho/h)/2./pi/1.e3
print "Theoretical frequency [kHz] = " + "%2.3f" % fTheory_kHz