from pylab import *
from scipy.special import jv, iv
from scipy.optimize import fsolve

rcParams['font.size'] = 20

x = linspace(0,12,200)
y = iv(1,x)*jv(0,x)+jv(1,x)*iv(0,x)

def eq(x):
    return(iv(1,x)*jv(0,x)+jv(1,x)*iv(0,x))
ic = 3,6,9
xo = zeros(3)
for i in range(0,len(ic)):
    xo[i] = fsolve(eq,ic[i])
figure(1)
clf()
ax=axes((.15,.15,.75,.75))
plot(x,y,color = 'k',linewidth = 2)
hold(True)
scatter(xo,zeros(xo.shape),marker = 'x',color = 'k',s = 120,linewidth = 2)
# for i in range(0,3):
#     text(2,xo+1,'a')
xlabel(r'$\beta r_a$',fontsize = 22)
ylabel(r'$I_1(\beta r_a)J_o(\beta r_a) - J_1(\beta r_a)I_o(\beta r_a)$',fontsize =22)
annotate(('%5.4f'%(xo[0]/pi))+'$\pi$', xy=(xo[0], 0), xytext=(xo[0]+.3, 1.5),
            arrowprops=dict(arrowstyle="->",
                                connectionstyle="arc3,rad=.2",shrinkB = 10))
annotate(('%5.4f'%(xo[1]/pi))+'$\pi$', xy=(xo[1], 0), xytext=(xo[1]+.3, 1.5),
            arrowprops=dict(arrowstyle="->",
                                connectionstyle="arc3,rad=.2",shrinkB = 10))
annotate(('%5.4f'%(xo[2]/pi))+'$\pi$', xy=(xo[2], 0), xytext=(xo[2]+.3, 1.5),
            arrowprops=dict(arrowstyle="->",
                                connectionstyle="arc3,rad=.2",shrinkB = 10))                                
# title(r'$\beta r_a = '+('%5.4f'%(xo[0]/pi))+'\pi, '+('%5.4f'%(xo[1]/pi))+'\pi, '+('%5.4f'%(xo[2]/pi))+'\pi $')
grid(True)
axis((0,12,-5,5))
xo = fsolve
show()