from pylab import *
from scipy.special import jv, iv
from scipy.optimize import fsolve

rcParams['font.size'] = 9

x = linspace(0,12,200)
y = 1-cos(x)*cosh(x)

def eq(x):
    return(1-cos(x)*cosh(x))
ic = 5,8,11
xo = zeros(4)
for i in range(0,len(ic)):
    xo[i] = fsolve(eq,ic[i])
figure(figsize=(4,3),dpi = 150)
clf()
ax=axes((.15,.15,.75,.75))
plot(x,y,color = 'k',linewidth = 2)
hold(True)
scatter(xo,zeros(xo.shape),marker = 'x',color = 'k',s = 50,linewidth = 1)

# for i in range(0,3):
#     text(2,xo+1,'a')
xlabel(r'$\beta r_a$',fontsize = 10)
ylabel(r'$1-cos(\beta L)cosh(\beta L)$',fontsize =10)
annotate(('%5.3f'%(xo[0])), xy=(xo[0], 0), xytext=(xo[0]+1, 15),
            arrowprops=dict(arrowstyle="->",
                                connectionstyle="arc3,rad=.2",shrinkB = 10))
annotate(('%5.3f'%(xo[1])), xy=(xo[1], 0), xytext=(xo[1]+1, 15),
            arrowprops=dict(arrowstyle="->",
                                connectionstyle="arc3,rad=.2",shrinkB = 10))
annotate(('%5.3f'%(xo[2])), xy=(xo[2], 0), xytext=(xo[2]+1, 15),
            arrowprops=dict(arrowstyle="->",
                                connectionstyle="arc3,rad=.2",shrinkB = 10))                                
# title(r'$\beta r_a = '+('%5.4f'%(xo[0]/pi))+'\pi, '+('%5.4f'%(xo[1]/pi))+'\pi, '+('%5.4f'%(xo[2]/pi))+'\pi $')
#grid(True)

axis((0,15,-50,50))
plot(xlim(),zeros(2),color ='k',linestyle = '--')
xo = fsolve
show()
savefig('Fig_6p43.eps')