from pylab import *
from enthought.mayavi import mlab

def vis2d(freq_kHz,v, n = 1):
    N1 = 5					# discretization in the radial direction
    N2 = 5					# number of elements in the theta-direction
    N  = N1*N2				# Number of DOF
    r_a= 200e-6				# Radius [m]
    h = 1e-6				# Height [m]
    nu = 0.3				# Poisson ratio
    Y = 150e9				# Young's modulus [N/m**2]
    rho = 2330				# Mass density [kg/m**3]
    D = Y*h**3/12/(1-nu**2)	# Plate modulus
    mlab.figure("Modal analysis",(1,1,1),(0,0,0))
    mlab.clf()
    q,r = meshgrid(linspace(0,2*pi,N2),linspace(0,1,N1))
    uF = v[:,n-1]/max(abs(v[:,n-1]))
    u = reshape(uF,r.shape)
    mlab.mesh(r*cos(q),r*sin(q),real(u),colormap = 'gray')
    fStr = "%2.3f" % freq_kHz[n-1]
    tit = 'Mode = ' + str(n) + ': f = ' + fStr + ' kHz'
    mlab.title(tit,size =12)
    # coeff = (1.015, 2.007, -5)
    if n == 1:
        coeff = 1.0174
    elif n == 2:
        coeff = 2.0074
    elif n == 3:
        coeff = 3.0047
    fTheory_kHz = (coeff*pi/r_a)**2 * sqrt(D/rho/h)/2./pi/1.e3
    print "Theoretical frequency [kHz] = " + "%2.3f" % fTheory_kHz