import numpy as np
import matplotlib.pyplot as plt

w = np.linspace(0,1.2,200);
zeta = np.arange(.5,1.3,.2)

ax = {}
ax['mag'] = plt.subplot(2,1,1)
ax['phi'] = plt.subplot(2,1,2)
plt.rcParams['font.size'] = 14
Cs = []
lnW = []
leg = []
d = .25
for i in range(0,len(zeta)):
    Cs.append( (i*d, i*d, i*d) )
    lnW.append(4-i*1)
    leg.append(r'$\zeta = '+str(zeta[i])+'$')
i = 0
for zetaC in zeta:
    mag = 1/((1-w**2)**2 + (2*w*zetaC)**2)
    phi = np.arctan2( -2*w*zetaC,1-w**2)*180/np.pi
    plt.axes(ax['mag'])
    plt.plot(w, mag,color = Cs[i],linewidth = lnW[i])
    plt.hold(True)
    plt.axes(ax['phi'])
    plt.plot(w,phi,color = Cs[i],linewidth = lnW[i])
    i+=1

plt.ylabel(r'Phase $\angle{H(\omega)}$ [deg]')
plt.xlabel(r'Normalized frequency $\omega/\omega_o$')
plt.grid(True)
plt.legend( leg, loc = 3)

ax['phi'].set_yticks((0,-30,-60,-90,-120))
plt.axes(ax['mag'])
plt.ylabel('Magnitude $|H(\omega)|/\omega_o^2$')
plt.grid(True)

plt.show()