import numpy as np
import matplotlib.pyplot as plt

w = np.linspace(0,.5,200);
zeta = np.arange(.675,.75,.025)

ax = {}
plt.rcParams['font.size'] = 9
plt.rcParams['font.family']='Arial'
lnS = []
leg = []
d = .25
plt.figure(figsize = (4,3),dpi = 150)
plt.axes((.15,.15,.8,.8))
for i in range(0,len(zeta)):
    if i == 0:
        lnS.append(':')
    elif i == 1:
        lnS.append('-')
    elif i == 2:
        lnS.append('--')
    leg.append(r'$\zeta = $'+str(zeta[i]))
i = 0
for zetaC in zeta:
    mag = 1/((1-w**2)**2 + (2*w*zetaC)**2)
    plt.plot(w, mag,color = 'k',linewidth = 1, linestyle = lnS[i])
    plt.hold(True)
    i+=1
xt = plt.gca().get_xaxis()
yt = plt.gca().get_yaxis()
for tl in xt.get_majorticklines():
    tl.set_linewidth = .05
for tl in yt.get_majorticklines():
    tl.set_linewidth = .05
plt.legend( leg, loc = 3)
plt.ylabel('Amplitude $|H(\omega)|/\omega_o^2$')
plt.xlabel('Frequency $\omega/\omega_o$')
plt.grid(False)
plt.show()
plt.savefig('Fig7p15.png')
plt.savefig('Fig7p15.eps')