import numpy as np
import matplotlib.pyplot as plt

w = np.linspace(0,.5,200);
zeta = np.arange(.675,.75,.025)

ax = {}
plt.rcParams['font.size'] = 18
Cs = []
lnW = []
leg = []
d = .25

for i in range(0,len(zeta)):
    Cs.append( (i*d, i*d, i*d) )
    lnW.append(4-i*1)
    leg.append(r'$\zeta = '+str(zeta[i])+'$')
i = 0
for zetaC in zeta:
    mag = 1/((1-w**2)**2 + (2*w*zetaC)**2)
    plt.plot(w, mag,color = Cs[i],linewidth = lnW[i])
    plt.hold(True)
    i+=1

plt.legend( leg, loc = 3)
plt.ylabel('Magnitude $|H(\omega)|/\omega_o^2$')
plt.xlabel('Frequency $\omega/\omega_o$')
plt.grid(True)
plt.show()