import numpy as np
import matplotlib.pyplot as plt

w = np.linspace(0,1.2,200);
zeta = np.arange(.5,1.3,.2)

ax = {}
ax['mag'] = plt.subplot(2,1,1)
ax['phi'] = plt.subplot(2,1,2)
plt.rcParams['font.size'] = 14
Cs = []
lnS = []
leg = []
d = .25
def addLab(ax,instr):
    xl = ax.get_xlim()
    yl = ax.get_ylim()
    print yl[1]-np.diff(yl)/10,xl[1]-np.diff(xl)/10
    plt.text(xl[1]-np.diff(xl)/10,yl[1]-np.diff(yl)/10, instr)

for i in range(0,len(zeta)):
    if i == 0:
        lnS.append(':')
    elif i == 1:
        lnS.append('--')
    elif i == 2:
        lnS.append('-.')
    elif i == 3:
        lnS.append('-')
    leg.append(r'$\zeta = $'+str(zeta[i]))
i = 0
for zetaC in zeta:
    mag = 1/((1-w**2)**2 + (2*w*zetaC)**2)
    phi = np.arctan2( -2*w*zetaC,1-w**2)*180/np.pi
    plt.axes(ax['mag'])
    plt.plot(w, mag,linestyle = lnS[i], linewidth = 2,color = 'k')
    plt.hold(True)
    plt.axes(ax['phi'])
    plt.plot(w,phi,linestyle = lnS[i],linewidth = 2, color = 'k')
    i+=1
plt.ylabel(r'Phase $\angle{H(\omega)}$ [deg]')
plt.xlabel(r'Normalized frequency $\omega/\omega_o$')
addLab(ax['phi'],'(b)')
plt.grid(True)
plt.legend( leg, loc = 3)
ax['phi'].set_yticks((0,-30,-60,-90,-120))
plt.axes(ax['mag'])
plt.ylabel('Amplitude $|H(\omega)|/\omega_o^2$')
plt.grid(True)
addLab(ax['mag'],'(a)')


plt.show()