import numpy as np
import matplotlib.pyplot as plt

w = np.linspace(0,2,800);
plt.figure(figsize=(5,4),dpi = 150)
ax = {}
ax['mag'] = plt.axes((.15,.55,.7,.3))
ax['phi'] = plt.axes((.15,.15,.7,.3))
plt.rcParams['font.size'] = 9
plt.rcParams['font.size'] = 9
plt.rcParams['font.family'] = 'Arial'
plt.rcParams['legend.fontsize']='medium'
d = .25
def addLab(ax,instr):
    xl = ax.get_xlim()
    yl = ax.get_ylim()
    plt.text(xl[1]-np.diff(xl)/10,yl[1]-np.diff(yl)/10, instr,
             verticalalignment = 'top')
def addLab2(ax,instr):
    xl = ax.get_xlim()
    yl = ax.get_ylim()
    plt.text(xl[1]-np.diff(xl)/10,yl[1]-np.diff(yl)/2, instr,
             verticalalignment = 'top')
Q =30
mag = 1/np.sqrt((1-w**2)**2 + (w/Q)**2)
phi = np.arctan2( -w/Q,1-w**2)*180/np.pi
plt.axes(ax['mag'])
plt.plot(w, mag, linewidth = 1,color = 'k')
plt.gca().set_yscale('log')
yl = plt.gca().get_ylim()
plt.fill(np.r_[w[w<=1],np.flipud(w[w<=1])],
         np.r_[mag[w<=1],yl[0]*np.ones(len(w[w<=1]))],
         color = np.ones(3)*.7)
plt.fill(np.r_[w[w>=1],np.flipud(w[w>=1])],
         np.r_[mag[w>=1],yl[0]*np.ones(len(w[w>=1]))],
         color = np.ones(3)*.9)
plt.text(.75,yl[0]+.05,r'$\omega_d < \omega_s$',
         horizontalalignment = 'center',
         verticalalignment = 'bottom',
         backgroundcolor = np.ones(3)*.7)
plt.text(1.25,yl[0]+.05,r'$\omega_d > \omega_s$',
         horizontalalignment = 'center',
         verticalalignment = 'bottom',
         backgroundcolor = np.ones(3)*.9)
plt.hold(True)
plt.axes(ax['phi'])
plt.plot(w,phi,linewidth = 1, color = 'k')
plt.ylabel(r'Phase $\angle{H(\omega)}$ [deg]')
plt.xlabel(r'Normalized frequency $\omega/\omega_o$')
addLab(ax['phi'],'(b)')
#plt.grid(True)
ax['phi'].set_yticks((0,-45,-90,-135,-180))
plt.axes(ax['mag'])
plt.ylabel('Amplitude $|H(\omega)|/\omega_o^2$')
#plt.grid(True)
addLab2(ax['mag'],'(a)')
plt.show()
plt.savefig('Fig7p27.png')
plt.savefig('Fig7p27.eps')