# -*- coding: utf-8 -*-
"""
Created on Tue Dec 20 08:52:25 2011

@author: NGN
"""

import sympy
import numpy as np
import matplotlib.pyplot as plt
# symbolic calcs
x,io = sympy.symbols('x,io',real = True)
L = 50e-8/(1+x*1e-8)
#L = 50e-8/(1+x*1e4)
Wc = 1./2*L*io**2
f = Wc.diff(x)
print '\n\n\nForce of electric origin\n\nfe = ',f
# numerical calcs
xu = np.linspace(0,200,80)
fN = np.zeros(len(xu))
for k in range(len(xu)):
    fN[k]= f.subs([(x,xu[k]*1e6),(io,1e-3)])*1e21

# show the results:
plt.figure()
plt.plot(xu,fN,color = 'k',linewidth = 2)
plt.xlabel(r'Mechanical displacement $x$ [$\mu$m]')
plt.ylabel(r'Electrical force $f^{e}$ [zN]')
plt.text(np.mean(plt.xlim()),np.mean(plt.ylim()), 
         r'$i_o$ = 1 mA',horizontalalignment = 'center')
plt.grid(True)
